import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;

import javax.swing.JOptionPane;

import jp.hishidama.zip.ZipEntry;
import jp.hishidama.zip.ZipOutputStream;
import jp.hishidama.zip.ZipFile;
import jp.hishidama.zip.ZipPasswordException;

//*****************************************************************
//*** ̃NXimportĂZIṔAjp.hishidama.zipł ***
//*****************************************************************
public class ArchivePasswordTestPassZip {
	//
	ArchivePasswordTest panel;
	File folder;
	//------------------------------------------------------------------RXgN^
	//
	public ArchivePasswordTestPassZip(ArchivePasswordTest parent){
		panel=parent;
	}
	//------------------------------------------------------------------ZIP擾
	//
	public String outputZipInfo(File file){
		StringBuffer buf=new StringBuffer();
		//
		try{
			buf.append(outputZipFileEntries(new ZipFile(file))+"\n");
		}catch(IOException e){
			return e.toString();
		}
		//
		return buf.toString();
	}
	//i[t@ČX̏
	private String outputZipFileEntries(ZipFile zipFile){
		StringBuffer buf=new StringBuffer();
		//
		Enumeration enm=zipFile.entries();
		buf.append("*** ZIP File Entries (by jp.hishidama.zip) ***"+"\n");
		//
		while(enm.hasMoreElements()){
			buf.append(((ZipEntry)enm.nextElement()).getName()+"\n");
		}
		//
		return buf.toString();
	}
	//------------------------------------------------------------------ZIPkipX[htɑΉj
	//
	public void filesToPasswordZip(File fileZip,File baseFolder,String password){
		//
		folder=baseFolder;
		//
		try{
			ZipOutputStream zos=new ZipOutputStream(new FileOutputStream(fileZip));
			if(!password.equals("")){	//pX[hΐݒ
				zos.setPassword(password.getBytes("MS932"));
			}
			//
			filesToZip(folder,zos);
			//
			zos.close();
			//
			JOptionPane.showMessageDialog(panel,"k܂(by jp.hishidama.zip)","",JOptionPane.INFORMATION_MESSAGE);
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(panel,ioe.toString(),"G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	//w肳ꂽtH_ȉɂSt@CZIPɏށiċAĂяoj
	private void filesToZip(File outFolder,ZipOutputStream zos) throws IOException{
		String[] outFilesList=outFolder.list();
		//
		File outFile;
		for(int f=0;f<outFilesList.length;f++){
			outFile=new File(outFolder.getPath()+File.separator+outFilesList[f]);	//΃pX
			//
			if(outFile.isFile()){				//t@CȂ珑
				fileToZipEntry(outFile,zos);
			}else if(outFile.isDirectory()){	//tH_ȂċAĂяo
				filesToZip(outFile,zos);
			}
		}
	}
	//w肳ꂽt@CZIPɏ
	private void fileToZipEntry(File outFile,ZipOutputStream zos) throws IOException{
		BufferedInputStream bis=new BufferedInputStream(new FileInputStream(outFile));
		//Gg[ǉi΃pX𑊑΃pXɏCj
		ZipEntry outEntry=new ZipEntry(outFile.getPath().substring(folder.getPath().length()+1));	//+1̓Zp[^[̕
		zos.putNextEntry(outEntry);
		//
		int b;
		while((b=bis.read())!=-1){
			zos.write((byte)b);
		}
		//
		zos.closeEntry();
		bis.close();
	}
	//------------------------------------------------------------------ZIP𓀁ipX[htɑΉj
	//
	public void passwordZipToFolder(File fileZip,File baseFolder,String password){
		//
		folder=baseFolder;
		//
		try {
			ZipFile zf=new ZipFile(fileZip);
			if(!password.equals("")){	//pX[hΐݒ
				zf.setPassword(password.getBytes("MS932"));
				zf.setCheckCrc(true);
			}
			//
			Enumeration enm=zf.entries();
			while(enm.hasMoreElements()){
				ZipEntry zipEntry=(ZipEntry)enm.nextElement();
				zipEntryToFile(zf,zipEntry);
			}
			//
			zf.close();
			//
			JOptionPane.showMessageDialog(panel,"𓀂܂(by jp.hishidama.zip)","",JOptionPane.INFORMATION_MESSAGE);
		}catch(ZipPasswordException e){
			JOptionPane.showMessageDialog(panel,e.toString(),"pX[hG[",JOptionPane.ERROR_MESSAGE);
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(panel,ioe.toString(),"G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	//
	private void zipEntryToFile(ZipFile zipFile,ZipEntry zipEntry) throws IOException{
		File outFile=new File(folder.getPath()+File.separator+zipEntry.getName());	//΃pX
		//
		if(outFile.isDirectory()){	//fBNgȂtH_쐬̂
			outFile.mkdirs();
		}else{						//t@CȂtH_쐬iKvȂjăt@Co
			//t@Ci[tH_܂݂ȂȂ̂ō쐬
			File parentFolder=new File(outFile.getParent());
			parentFolder.mkdirs();
			//
			BufferedInputStream bis=new BufferedInputStream(zipFile.getInputStream(zipEntry));
			BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(outFile));
			//
			int b;
			while((b=bis.read())!=-1){
				bos.write((byte)b);
			}
			//
			bis.close();
			bos.close();
		}
	}
}
